## ros-kinetic-multisense-ros 4.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(multisense_ros)

find_package(Boost REQUIRED COMPONENTS thread)

find_package(catkin REQUIRED COMPONENTS roscpp
                                        std_msgs
                                        genmsg
                                        tf
                                        multisense_lib
                                        rosbag
                                        sensor_msgs
                                        geometry_msgs
                                        image_transport
                                        angles
                                        cv_bridge
                                        dynamic_reconfigure
                                        image_geometry
                                        message_generation)

set(CMAKE_C_FLAGS "-O2")
set(CMAKE_CXX_FLAGS "-O2")

generate_dynamic_reconfigure_options(cfg/multisense.cfg)

add_message_files(DIRECTORY msg
                  FILES
                  DeviceInfo.msg
                  RawCamConfig.msg
                  RawImuData.msg
                  RawLidarData.msg
                  RawCamCal.msg
                  RawCamData.msg
                  RawLidarCal.msg
                  Histogram.msg
                  DeviceStatus.msg
                  StampedPps.msg)

generate_messages(DEPENDENCIES sensor_msgs)

catkin_package(INCLUDE_DIRS   include
               CATKIN_DEPENDS roscpp
                              std_msgs
                              genmsg
                              tf
                              multisense_lib
                              rosbag
                              sensor_msgs
                              angles
                              cv_bridge
                              dynamic_reconfigure
                              image_geometry
                              image_transport
                              message_runtime
                              message_generation
               LIBRARIES      ${PROJECT_NAME})

include_directories(include
                    ${catkin_INCLUDE_DIRS}
                    ${Boost_INCLUDE_DIRS}
                    ${multisense_lib_INCLUDE_DIRS})

## Multisense Library


add_library(${PROJECT_NAME} src/camera.cpp
                          src/imu.cpp
                          src/laser.cpp
                          src/pps.cpp
                          src/status.cpp
                          src/reconfigure.cpp)

add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_gencfg)
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_generate_messages_cpp)
add_dependencies(${PROJECT_NAME} multisense_lib)

target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES}
                                      ${Boost_LIBRARIES}
                                      ${multisense_lib_LIBRARIES})


set_target_properties(${PROJECT_NAME}
  PROPERTIES LINK_FLAGS "-L${PROJECT_SOURCE_DIR}/../multisense_lib/sensor_api/bin/")
set_target_properties(${PROJECT_NAME}
  PROPERTIES COMPILE_FLAGS "-I${PROJECT_SOURCE_DIR}/../multisense_lib/sensor_api/source/LibMultiSense")

## ROS Driver

add_executable(ros_driver src/ros_driver.cpp)
target_link_libraries(ros_driver ${PROJECT_NAME}
                                 turbojpeg)
set_target_properties(ros_driver
  PROPERTIES COMPILE_FLAGS "-I${PROJECT_SOURCE_DIR}/../multisense_lib/sensor_api/source/LibMultiSense")

add_dependencies(ros_driver ${PROJECT_NAME}_generate_messages_cpp)


## Raw Snapshot

add_executable(raw_snapshot src/raw_snapshot.cpp)
add_dependencies(raw_snapshot ${PROJECT_NAME}_generate_messages_cpp)
add_dependencies(raw_snapshot multisense_lib)
target_link_libraries(raw_snapshot ${catkin_LIBRARIES}
                                   ${Boost_LIBRARIES}
                                   ${multisense_lib_LIBRARIES})

set_target_properties(raw_snapshot
  PROPERTIES COMPILE_FLAGS "-I${PROJECT_SOURCE_DIR}/../multisense_lib/sensor_api/source/LibMultiSense")


## Color Laser Point Cloud


add_executable(color_laser_publisher src/color_laser.cpp)
target_link_libraries(color_laser_publisher ${catkin_LIBRARIES}
                                            ${Boost_LIBRARIES})

## Install
## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME} ros_driver raw_snapshot color_laser_publisher
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install (DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/docs
         DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-kinetic-multisense-ros (4.0.4-1xenial) xenial; urgency=high

  * update release to reference github instead of bitbucket

 -- Carnegie Robotics <support@carnegierobotics.com>  Wed, 01 Jul 2020 04:00:00 -0000

ros-kinetic-multisense-ros (4.0.3-1xenial) xenial; urgency=high

  * undo early commit
  * incremented package.xml version numbers for next release
  * Contributors: Quentin Torgerson <mailto:qtorgerson@carnegierobotics.com>

 -- Carnegie Robotics <support@carnegierobotics.com>  Tue, 07 Jan 2020 05:00:00 -0000

ros-kinetic-multisense-ros (4.0.2-1xenial) xenial; urgency=high

  * added C++98 compatibility
  * Contributors: Quentin Torgerson <mailto:qtorgerson@carnegierobotics.com>

 -- Carnegie Robotics <support@carnegierobotics.com>  Wed, 03 Apr 2019 04:00:00 -0000

ros-kinetic-multisense-ros (3.3.0-1xenial) xenial; urgency=high

  * Updated LibMultiSense to build under C++11. Added URDF for the MultiSense S7/S7S and BCAM. Added support for 16 bit mono images. Added support for the MultiSense ST21 thermal stereo camera. Added organized pointcloud publishing. Changed laser and camera pointcloud color fields to FLOAT32 for PCL compatibility. Changed default color image encoding to BGR8. Added spindle joint publishing via the ROS joint_state_publisher. Updated multisense_cal_check to handle various serial number entires. Added the launch-file sensor parameter to load different URDF’s on startup. Published camera info topics for each image topic (for unrectified topics K, D, and R are populated). Added default laser transform publishing to keep the laser TF tree valid even when there are no subscriptions to laser topics.
  * Changed license from LGPL to BSD in both the ROS Driver and LibMultiSense C++ library. Fixed bug in disparity image publishing.  Fixed bug in raw_cam_config publishing.  Fixed bug in building using rosbuild under Groovy, Hydro, Indigo, etc.  Fixed Jenkins linking issue with libpng. Fixed termination bug in process_bags.py.
  * Add anonymous namespace so driver objects can properly deconstruct before the comm channel is destroyed.
  * Add histogram topic (only published when subscribed to an image topic.)  Fix bitbucket issue #5 (color pointcloud published at a very slow rate.) Misc. fixes to build configuration.
  * Add initial support for CRL's Mono IP Camera. Numerous fixes in catkin build infrastructure.
  * Add support for catkin and rosbuild (Builds under Fuerte, Groovy, Hydro, and Indigo). Transitioned laser calibration from KDL and joint_state_publisher to pure ROS TF messages. Add support for multiple Multisene units via namespacing and tf_prefix's. Modified default topic names to reflect the new namespacing parameters (Default base namespace is now /multisense rather than /multisense_sl). Add support for 3.1_beta sensor firmware which includes support for Multisense-S21 units. Please note that the 3.1 ROS driver release is fully backwards compatible with all 2.X firmware versions.
  * Release_3.0_beta: Add support for 3.0_beta sensor firmware (SGM hardware stereo core: disparity at all resolutions, 2:1 rectangular pixel modes, 64/128/256 disparity modes, hardware bi-lateral post-stereo disparity filter support with tuning), add colorized points2 topic, add pointcloud egde and range filtering, add raw left/right disparitiy image topics, add stereo-cost image topic, misc other feature enhancements and bugfixes.  Please note that the 3.0_beta release is fully backwards compatiblie with all 2.X firmware versions.
  * Release_2.3: Add support for 2.3 sensor firmware (IMU / CMV4000 support), add 'MultiSenseUpdater' firmware upgrade tool, add smart dynamic_reconfigure presentation, remove multisense_diagnostics/multisense_dashboard, wire protocol to version 3.0 (w/ support for forthcoming SGM core), misc. other bugfixes and feature enhancements.
  * Check that the sensor is running firmware version 2.2 or higher before enabling the PPS topic. Firmware version 2.1 had a rare bug where the timecode of the last PPS pulse is published.
  * Release_2.1: fix a few minor files that were mistakenly changed
  * -Add PPS topic: /multisense_sl/pps (std_msgs/Time)
    -Corrected step size of color images, which now display correctly using image_view
    -Add 'network_time_sync' option to dynamic reconfigure
  * Corrected projection center in cached camera intrinsics.  This resolves an issue with misaligned laser / stereo data in rviz point cloud visualization.
  * Corrected variable names in pointcloud2 output.  This resolves issue #20, "Naming convention in laser.cpp isn't consistent."
  * Imported Release 2.0 of MultiSense-SL ROS driver.
  * Contributors: David LaRose <mailto:dlr@carnegierobotics.com>, Eric Kratzer <mailto:ekratzer@carnegierobotics.com>, Matt Alvarado <mailto:malvarado@carnegierobotics.com>

 -- Carnegie Robotics <support@carnegierobotics.com>  Tue, 30 Sep 2014 04:00:00 -0000

=== debian/control ===
Source: ros-kinetic-multisense-ros
Section: misc
Priority: optional
Maintainer: Carnegie Robotics <support@carnegierobotics.com>
Build-Depends: debhelper (>= 9.0.0), libjpeg-turbo8-dev, libturbojpeg, libyaml-cpp-dev, ros-kinetic-angles, ros-kinetic-catkin, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-genmsg, ros-kinetic-geometry-msgs, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-message-runtime, ros-kinetic-multisense-lib, ros-kinetic-rosbag, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf
Homepage: https://github.com/carnegierobotics/multisense_ros
Standards-Version: 3.9.2

Package: ros-kinetic-multisense-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjpeg-turbo8-dev, libturbojpeg, ros-kinetic-angles, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-genmsg, ros-kinetic-geometry-msgs, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-message-runtime, ros-kinetic-multisense-lib, ros-kinetic-rosbag, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf
Description: multisense_ros

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-multisense-ros//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
